deriv[E; V] =
  [constant-p[E] --> make-constant[0];
   variable-p[E] -->
     [eq[var-name[E]; var-name[V]] --> make-constant[1];
      otherwise --> make-constant[0]];
   negation-p[E] --> make-negation[deriv[operand[E]; V]];
   product-p[E] -->
     make-sum
       [make-product[operand1[E]; deriv[operand2[E]; V]];
        make-product[operand2[E]; deriv[operand1[E]; V]]];
   quotient-p[E] -->
     make-quotient
       [make-difference
          [make-product[operand2[E]; deriv[operand1[E]; V]];
           make-product[operand1[E]; deriv[operand2[E]; V]]];
        make-power[operand2[E]; make-constant[2]]];
   sum-p[E] -->
     make-sum[deriv[operand1[E]; V]; deriv[operand2[E]; V]];
   difference-p[E] -->
     make-difference[deriv[operand1[E]; V]; deriv[operand2[E]; V]];
   power-p[E] -->
     make-product
       [make-product[exponent[E]; deriv[base[E]; V]];
        make-power
          [base[E]; make-constant[minus[const-val[exponent[E]]; 1]]]];
   exponential-p[E] --> make-product[E; deriv[argument[E]; V]];
   sine-p[E] -->
     make-product[make-cosine[argument[E]]; deriv[argument[E]; V]];
   cosine-p[E] -->
     make-negation
       [make-product[make-sine[argument[E]]; deriv[argument[E]; V]]]]
