;;;
;;; An "environment" ADT implemented using association lists.
;;; 
defined-p[env; name] =
  [endp[assoc[env; name]] --> F;
   otherwise --> T]

apply-env[env; name] =
  {binding = assoc[env; name] :
   [endp[binding] --> error2[(Undefined symbol --); name];
    otherwise --> assoc-val[binding]]}

extend-env[env; name; value] = cons[make-binding[name; value]; env]

null-env = ()
